#include <iostream>

using namespace std;

int main()
{
    short int n;
    cin >> n;
    char grafmapa[n][n];
    short int prvi;
    short int drugi;
    char car;
    int resenje = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            grafmapa[i][j] = ' ';
        }
    }
    for (int i = 0; i < n-1; i++) {
        cin >> prvi >> drugi >> car;
        if (prvi > drugi) {
            grafmapa[drugi - 1][prvi - 1] = car;
        }
        else {
            grafmapa[prvi - 1][drugi - 1] = car;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (grafmapa[i][j] == 'S') {
                for (int kec = 0; kec < n; kec++) {
                    if (grafmapa[i][kec] == 'I') {
                        for (int keckec = 0; keckec < n; keckec++) {
                            if (grafmapa[kec][keckec] == 'O') {
                                resenje++;
                            }
                        }
                    }
                }
                for (int drugi = 0; drugi < n; drugi++) {
                    if (grafmapa[j][drugi] == 'I') {
                        for (int drugikec = 0; drugikec < n; drugikec++) {
                            if (grafmapa[drugi][drugikec] == 'O') {
                                resenje++;
                            }
                        }
                    }
                }
            }
        }
    }
    cout << resenje;
}